/************************************************************
* $Id: main.c,v 1.2 2014/11/17 10:21:22 mechanoid Exp $
*
*       OS : GNU/Linux 3.14.19 x86_64
* COMPILER : GNU project C and C++ Compiler  v. 4.9.1
*
*   AUTHOR : Evgeny S. Borisov
*
*  Glushkov Institute of Cybernetics
*  National Academy of Sciences of Ukraine
* 
*    http://www.mechanoid.kiev.ua
*  e-mail : cv@mechanoid.kiev.ua
* 
************************************************************/
#include <stdio.h>
#include <cv.h>
#include <highgui.h>

#define WIN_SRC   "original - ocv-example"
#define WIN_DLT   "dilate - ocv-example"
#define WIN_ERD   "erode - ocv-example"
#define WIN_CLS   "close - ocv-example"
#define WIN_OPN   "open - ocv-example"

IplImage *frame_c1[2];

IplConvKernel* kern;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
int init(int argc, char* argv[]);
int run(char* argv[]);
void done();

void update(int pos, void* userdata);

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
int main(int argc, char* argv[]) {
   if(!init(argc,argv)) { run(argv); }
   done();
   return 0;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
int init(int argc, char* argv[]) {
   int frame_w;
   int frame_h;

   if(argc<3) { return 1; }

   // получаем картинку
   frame_c1[0] = cvLoadImage(argv[1],CV_LOAD_IMAGE_GRAYSCALE);
   if( !frame_c1[0]) { fprintf(stderr,"[E] cvLoadImage\n"); return 1; }

   frame_w=frame_c1[0]->width;
   frame_h=frame_c1[0]->height;
   fprintf(stdout,"[i] %ix%i \n",frame_w,frame_h);

   frame_c1[1] = cvCloneImage(frame_c1[0]);
   if( !frame_c1[1]) { fprintf(stderr,"[E] cvCloneImage\n"); return 1; }

   // kern = cvCreateStructuringElementEx(r*2+1, r*2+1, r, r, CV_SHAPE_ELLIPSE,NULL);
   kern = cvCreateStructuringElementEx(3, 3, 2, 2, CV_SHAPE_RECT,NULL);
   if(!kern){ fprintf( stderr, "[E] cvCreateStructuringElementEx\n"); return 5; }

   // открываем и размещаем окна
   cvNamedWindow(WIN_SRC, CV_WINDOW_AUTOSIZE ); 
   cvMoveWindow(WIN_SRC, 10,20);
   
   cvNamedWindow(WIN_DLT, CV_WINDOW_AUTOSIZE ); 
   cvMoveWindow(WIN_DLT, 10+(10+frame_w)*0,20+(20+frame_h));

   cvNamedWindow(WIN_ERD, CV_WINDOW_AUTOSIZE ); 
   cvMoveWindow(WIN_ERD, 10+(10+frame_w)*1,20+(20+frame_h));

   cvNamedWindow(WIN_CLS , CV_WINDOW_AUTOSIZE ); 
   cvMoveWindow(WIN_CLS, 10+(10+frame_w)*0,20+(20+frame_h)*2);

   cvNamedWindow(WIN_OPN, CV_WINDOW_AUTOSIZE ); 
   cvMoveWindow(WIN_OPN, 10+(10+frame_w)*1,20+(20+frame_h)*2);

   fprintf(stdout,"[i] press any key to exit...\n");

   return 0;
}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
void done(){
   cvDestroyAllWindows();
   cvReleaseImage(&frame_c1[0]);
   cvReleaseImage(&frame_c1[1]);
   cvReleaseStructuringElement( &kern );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
int run(char* argv[]) { 
   cvShowImage( WIN_SRC, frame_c1[0]); 

   cvMorphologyEx( frame_c1[0], frame_c1[1], NULL, kern, CV_MOP_DILATE, 1 );
   cvShowImage( WIN_DLT, frame_c1[1]); 
   cvMorphologyEx( frame_c1[0], frame_c1[1], NULL, kern, CV_MOP_ERODE, 1 );
   cvShowImage( WIN_ERD, frame_c1[1]); 
   cvMorphologyEx( frame_c1[0], frame_c1[1], NULL, kern, CV_MOP_CLOSE, 1 );
   cvShowImage( WIN_CLS, frame_c1[1]); 
   cvMorphologyEx( frame_c1[0], frame_c1[1], NULL, kern, CV_MOP_OPEN , 1 );
   cvShowImage( WIN_OPN, frame_c1[1]); 


   cvWaitKey(0); 
   // cvSaveImage(argv[2],frame_c1[1],0);

   return 0;
}
