/************************************************************
* $Id: main.c,v 1.3 2014/11/17 11:17:10 mechanoid Exp mechanoid $
*
*       OS : GNU/Linux 3.14.19 x86_64
* COMPILER : GNU project C and C++ Compiler  v. 4.9.1
*
*   AUTHOR : Evgeny S. Borisov
*
*  Glushkov Institute of Cybernetics
*  National Academy of Sciences of Ukraine
* 
*    http://www.mechanoid.kiev.ua
*  e-mail : cv@mechanoid.kiev.ua
* 
************************************************************/
#include <stdio.h>
#include <cv.h>
#include <highgui.h>

#define WIN_SRC   "original - ocv-example"
#define WIN_RES   "result - ocv-example"

IplImage *frame_c3[2];

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
int init(int argc, char* argv[]);
int run(char* argv[]);
void done();

void update(int pos, void* userdata);

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
int main(int argc, char* argv[]) {
   if(!init(argc,argv)) { run(argv); }
   done();
   return 0;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
int init(int argc, char* argv[]) {
   int frame_w;
   int frame_h;

   if(argc<3) { return 1; }

   // получаем картинку
   frame_c3[0] = cvLoadImage(argv[1],CV_LOAD_IMAGE_COLOR);
   if( !frame_c3[0]) { fprintf(stderr,"[E] cvLoadImage\n"); return 1; }

   frame_w=frame_c3[0]->width;
   frame_h=frame_c3[0]->height;
   fprintf(stdout,"[i] %ix%i \n",frame_w,frame_h);

   frame_c3[1] = cvCloneImage(frame_c3[0]);
   if( !frame_c3[1]) { fprintf(stderr,"[E] cvCloneImage\n"); return 1; }

   // открываем и размещаем окна
   cvNamedWindow(WIN_SRC, CV_WINDOW_AUTOSIZE ); 
   cvMoveWindow(WIN_SRC, 10, 20 );
  
   cvNamedWindow(WIN_RES, CV_WINDOW_AUTOSIZE ); 
   cvMoveWindow(WIN_RES, 10+(10+frame_w)*1, 20 );

   fprintf(stdout,"[i] press any key to exit...\n");

   return 0;
}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
void done(){
   cvDestroyAllWindows();
   cvReleaseImage(&frame_c3[0]);
   cvReleaseImage(&frame_c3[1]);
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
int run(char* argv[]) { 
   float k[]={ 0.04 , 0.04 , 0.04, 0.04, 0.04,
			   0.04 , 0.04 , 0.04, 0.04, 0.04,
			   0.04 , 0.04 , 0.04, 0.04, 0.04,
			   0.04 , 0.04 , 0.04, 0.04, 0.04,
			   0.04 , 0.04 , 0.04, 0.04, 0.04 } ;

   CvMat mk=cvMat(5,5,CV_32FC1,&k);

   cvShowImage( WIN_SRC, frame_c3[0]); 

   cvFilter2D(frame_c3[0], frame_c3[1], &mk, cvPoint(-1,-1));

   cvShowImage( WIN_RES, frame_c3[1]); 

   cvWaitKey(0); 
   cvSaveImage(argv[2],frame_c3[1],0);

   return 0;
}
